#include <iostream>
#include <stdio.h>
#include <vector>
#include <stdlib.h>
#include <algorithm>

#define pb push_back

using namespace std;

const int MAXN = 1 << 20;

struct Node {
	int before;
	int after;
};

int n, m;
Node p[MAXN];
vector<int> vec;
int bit[MAXN];
int dp[MAXN];

void remove(int x) {
	p[ p[x].before ].after = p[x].after;
	p[ p[x].after ].before = p[x].before;
	p[x].before = p[x].after = -1;
}

void put(int a, int b) {
	int c = p[a].after;
	
	p[a].after = b;
	
	p[b].before = a;
	p[b].after = c;
	
	p[c].before = b;
}

void read() {
	int cmd, x, y;
	
	scanf("%d %d", &n, &m);
	
	for(int i = 0; i <= n + 1; i ++) {
		p[i].before = i - 1;
		p[i].after = i + 1;
	}
	
	for(int i = 0; i < m; i ++) {
		scanf("%d %d %d", &cmd, &x, &y);
		x ++, y ++;
		
		if(x == y) {
			printf("X == Y\n");
			exit(0);
		}
		
		remove(x);
		if(cmd == 1) put(y, x);
		else put(p[y].before, x);
	}
}

int get(int idx) {
	int ret = 0;
	while(idx) {
		if(ret < bit[idx]) ret = bit[idx];
		idx -= (idx & -idx);
	}
	return ret;
}

void update(int idx, int val) {
	while(idx <= n) {
		if(bit[idx] < val) bit[idx] = val;
		idx += (idx & -idx);
	}
}

void solve() {
	int cur = 0;
	for( ; ; ) {
		cur = p[cur].after;
		if(cur == n + 1) break;
		vec.pb(cur);
	}
	
	reverse(vec.begin(), vec.end());
	
	int ans = 0;
	for(int i = 0; i < (int)vec.size(); i ++) {
		int tmp = get(vec[i]) + 1;
		
		if(tmp > ans) ans = tmp;
		
		dp[ vec[i] ] = tmp;
		update(vec[i], tmp);
	}
	
	printf("%d\n", n - ans);
}

int main()
{
	freopen("sequence.in", "r", stdin);
	freopen("sequence.out", "w", stdout);
	
	read();
	solve();

    return 0;
}
